---
title: ReferenceError() constructor
slug: Web/JavaScript/Reference/Global_Objects/ReferenceError/ReferenceError
tags:
  - Constructor
  - JavaScript
  - Reference
  - ReferenceError
---
<div>{{JSRef}}</div>

<p>The <strong><code>ReferenceError</code></strong> object represents an error when a non-existent variable is referenced.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">new ReferenceError([<var>message</var>[, <var>fileName</var>[, <var>lineNumber</var>]]])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>message</var></code> {{optional_inline}}</dt>
 <dd>Human-readable description of the error.</dd>
 <dt><code><var>fileName</var></code> {{optional_inline}}</dt>
 <dd>The name of the file containing the code that caused the exception.</dd>
 <dt><code><var>lineNumber</var></code> {{optional_inline}}</dt>
 <dd>The line number of the code that caused the exception</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Catching_a_ReferenceError">Catching a ReferenceError</h3>

<pre class="brush: js notranslate">try {
  let a = undefinedVariable
} catch (e) {
  console.log(e instanceof ReferenceError)  // true
  console.log(e.message)                    // "undefinedVariable is not defined"
  console.log(e.name)                       // "ReferenceError"
  console.log(e.fileName)                   // "Scratchpad/1"
  console.log(e.lineNumber)                 // 2
  console.log(e.columnNumber)               // 6
  console.log(e.stack)                      // "@Scratchpad/2:2:7\n"
}
</pre>

<h3 id="Creating_a_ReferenceError">Creating a ReferenceError</h3>

<pre class="brush: js notranslate">try {
  throw new ReferenceError('Hello', 'someFile.js', 10)
} catch (e) {
  console.log(e instanceof ReferenceError)  // true
  console.log(e.message)                    // "Hello"
  console.log(e.name)                       // "ReferenceError"
  console.log(e.fileName)                   // "someFile.js"
  console.log(e.lineNumber)                 // 10
  console.log(e.columnNumber)               // 0
  console.log(e.stack)                      // "@Scratchpad/2:2:9\n"
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-nativeerror-constructors', 'NativeError constructor')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.ReferenceError.ReferenceError")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Error")}}</li>
</ul>
